#include "flutppc.h"
#include "encrypt.h"
// Fractal encryption code for 60 decimal places.
// encrypt() takes a string and encrypts it into a 60-digit decimal number
// decrypt() takes a 60-digit decimal number and decrypts it into a string
// This is intended for up to 10-chars long strings.
// Key for decryption is a 60-digit decimal number "key" 
// ETO 06/04/1999

int len[4];
Ereal r0_5("0.5"),r0_25("0.25");

Ereal f(Ereal x, Ereal &key)
{
 Ereal z;

 z = um - x;
 z = key * z;
 z = z * x;

 return(z);
}

Ereal f0(Ereal x, Ereal &key)
{
 Ereal z;

 // f0(x)=1/2-1/2*sqrt(1/4-x/k)
 z = x / key;
 z = - z;
 z = r0_25 + z;
 z =  raiz(z);
 z = r0_5 - z;

 return(z);
}

Ereal f1(Ereal x, Ereal &key)
{
 Ereal z;

 // f1(x)=1/2+1/2*sqrt(1/4-x/k)
 z = x / key;
 z = - z;
 z = r0_25 + z;
 z =  raiz(z);
 z = r0_5 + z;

 return(z);
}

int encrypt(char *inText, Ereal &cryptText, Ereal &key, int k)
{
int i[8],j;
Ereal oldCryptText,delta;
char *ptr;

len[k] = strlen(inText);

cryptText = r0_5;
oldCryptText = r0_5;
do {
  ptr = inText;
  while (*ptr) {
    i[0] = ((*ptr) & 1) >> 0 ;
    i[1] = ((*ptr) & 2) >> 1;
    i[2] = ((*ptr) & 4) >> 2;
    i[3] = ((*ptr) & 8) >> 3;
    i[4] = ((*ptr) & 16) >> 4;
    i[5] = ((*ptr) & 32) >> 5;
    i[6] = ((*ptr) & 64) >> 6;
    i[7] = ((*ptr) & 128) >> 7;

    for (j=0;j<8;++j) {
       if (i[j] == 0) {
         cryptText = f0(cryptText,key);
       }
       else if (i[j] == 1) {
         cryptText = f1(cryptText,key);
       }
       else throw(Exception("Severe error"));
    }

    ptr++;
  }
  delta = absol(cryptText - oldCryptText);
  oldCryptText = cryptText;
} while (eps<delta);
}

int decrypt(Ereal &inText, char *decryptText, Ereal &key ,int k)
{
 const char nums[] = {1,2,4,8,16,32,64,128};
 int i,j;

 memset(decryptText,0,len[k]+1);
 decryptText += len[k]-1;

 for (j=0;j<len[k];++j) {
   for (i=0;i<8;++i) {
     if (inText<r0_5)
       (*decryptText) |= 0;
     else
       (*decryptText) |= nums[7-i];
     inText = f(inText,key);
   }
   decryptText--;
 }
}
