#include "flutppc.h"
// Fractal encryption code for 100 decimal places.
// ETO 01/04/1999

int len;
Ereal key ("5.141241634589734634432643463256536354252332529352103464454844467474846468488408998628034825342117067982"),
      key2("5.141241634589734634432643463256536354252332529352103464454844467474846468488408998628034825342117067982"),
r0_5("0.5"),r0_25("0.25");

Ereal f(Ereal x)
{
 Ereal z;

 z = um - x;
 z = key2 * z;
 z = z * x;
 
 return(z);
}

Ereal f0(Ereal x)
{
 Ereal z;

 // f0(x)=1/2-1/2*sqrt(1/4-x/k)
 z = x / key;
 z = - z;
 z = r0_25 + z;
 z =  raiz(z);
 z = r0_5 - z;

 return(z);
}

Ereal f1(Ereal x)
{
 Ereal z;

 // f1(x)=1/2+1/2*sqrt(1/4-x/k)
 z = x / key;
 z = - z;
 z = r0_25 + z;
 z =  raiz(z);
 z = r0_5 + z;

 return(z);
}

int encrypt(char *inText, Ereal &cryptText)
{
int i[8],j;
Ereal oldCryptText,delta;
char *ptr;

len = strlen(inText);

cryptText = r0_5;
oldCryptText = r0_5;
do {
  ptr = inText;
  while (*ptr) {
    i[0] = ((*ptr) & char(1)) >> 0 ;
    i[1] = ((*ptr) & char(2)) >> 1;
    i[2] = ((*ptr) & char(4)) >> 2;
    i[3] = ((*ptr) & char(8)) >> 3;
    i[4] = ((*ptr) & char(16)) >> 4;
    i[5] = ((*ptr) & char(32)) >> 5;
    i[6] = ((*ptr) & char(64)) >> 6;
    i[7] = ((*ptr) & char(128)) >> 7;

    for (j=0;j<8;++j) {
       if (i[j] == 0) {
         cryptText = f0(cryptText);
       }
       else if (i[j] == 1) {
         cryptText = f1(cryptText);
       }
       else throw(Exception("Severe error"));
    }

    ptr++;
  }
  delta = absol(cryptText - oldCryptText);
  oldCryptText = cryptText;
} while (eps<delta);
}

int decrypt(Ereal &inText, char *decryptText)
{
 const char nums[] = {1,2,4,8,16,32,64,128};
 int i,j;

 memset(decryptText,0,len+1);
 decryptText += len-1;

 for (j=0;j<len;++j) {
   for (i=0;i<8;++i) {
     if (inText<r0_5)
       (*decryptText) |= 0;
     else
       (*decryptText) |= nums[7-i];
     inText = f(inText);
   }
   decryptText--;
 }
}
