/* FLUTPP.H - Arquivo de definicao dos operadores de comparacao,
   operadores auxiliares de operadores aritmeticos para numeros
   do tipo Ereal                                                  */

#ifndef __FLUTPP_H
#define __FLUTPP_H

#include <ctype.h>

#define TRUE 1
#define FALSE 0

#define TAM_DOUBLE      25
#define DIGITOS_DOUBLE  15

#define ZERO  "0"
#define UM    "1"
#define EPS   "1E-1000000"
#define PI1_2 "1.5707963267948966192313216916397514420985"
#define PI    "3.141592653589793238462643383279502884197"
#define PI3_2 "4.7123889803846898576939650749192543262955"
#define PI_2  "6.283185307179586476925286766559005768394"
#define E     "2.7182818284590452353602874713526624977552"

#define max 1000004
const max_int=3;
const max_dec=1000000;
const max_tot=1000003;

#define _FAR 
#define _FARFUNC 

class Ereal {

public:
 // Operador =
 Ereal _FAR & operator=(const Ereal& x);

 // Funcoes auxiliares
 friend Ereal _FARFUNC subt_f(Ereal, Ereal);
 friend Ereal _FARFUNC mult_alg(Ereal, char);
 void desce_alg(char);
 void desce_2alg(char, char);
 int  tam_int();
 int  tam_dec();
 void desl_esq(int);
 void desl_dir(int);
 void zera();

 // Construtores
 Ereal();
 Ereal(char *number);
 Ereal(const Ereal &x);

 // Destrutor
 ~Ereal();

 // Conversao para double
 friend double _FARFUNC dbl(Ereal _FAR &);
 friend Ereal _FARFUNC re(double);

 // Funcoes de E/S
 friend void _FARFUNC mostra(Ereal _FAR &);
 friend void _FARFUNC le_numero(Ereal *x);

 // Operadores e funcoes
 friend char _FARFUNC operator >(Ereal _FAR &, Ereal _FAR &);
 friend char _FARFUNC operator <(Ereal _FAR &, Ereal _FAR &);
 friend char _FARFUNC operator ==(Ereal _FAR &, Ereal _FAR &);
 friend char _FARFUNC operator !=(Ereal _FAR &, Ereal _FAR &);
 friend char _FARFUNC operator >=(Ereal _FAR &, Ereal _FAR &);
 friend char _FARFUNC operator <=(Ereal _FAR &, Ereal _FAR &);
 friend Ereal _FARFUNC operator +(Ereal _FAR &, Ereal _FAR &);
 friend Ereal _FARFUNC operator -(Ereal _FAR &, Ereal _FAR &);
 friend Ereal _FARFUNC operator *(Ereal _FAR &, Ereal _FAR &);
 friend Ereal _FARFUNC operator /(Ereal _FAR &, Ereal _FAR &);
 Ereal _FAR & operator+=(Ereal _FAR &);
 Ereal _FAR & operator-=(Ereal _FAR &);
 Ereal _FAR & operator*=(Ereal _FAR &);
 Ereal _FAR & operator/=(Ereal _FAR &);
 Ereal _FAR operator+();
 Ereal _FAR operator-();

 friend void _FARFUNC troca(Ereal _FAR &, Ereal _FAR &);
 friend Ereal _FARFUNC r(char *);
 friend Ereal _FARFUNC eleva(Ereal _FAR &, int);
 friend Ereal _FARFUNC fatorial(int&);
 friend Ereal _FARFUNC raiz(Ereal _FAR &);
 friend Ereal _FARFUNC absol(Ereal _FAR &);
 friend Ereal _FARFUNC frac(Ereal _FAR &);
 friend Ereal _FARFUNC inteiro(Ereal _FAR &);
 friend Ereal _FARFUNC exponencial(Ereal _FAR &);
 friend Ereal _FARFUNC seno(Ereal  &);
 friend Ereal _FARFUNC cosseno(Ereal _FAR &);

private:
 char *d;
 int e;
};

extern Ereal zero,um,eps,pi1_2,pi,pi3_2,pi_2,e;

extern char operator >(Ereal _FAR &, Ereal _FAR &);
extern char operator <(Ereal _FAR &, Ereal _FAR &);
extern char operator ==(Ereal _FAR &, Ereal _FAR &);
extern char operator !=(Ereal _FAR &, Ereal _FAR &);
extern char operator >=(Ereal _FAR &, Ereal _FAR &);
extern char operator <=(Ereal _FAR &, Ereal _FAR &);

extern void troca(Ereal _FAR &, Ereal _FAR &);
extern Ereal r(char*);

extern Ereal operator +(Ereal _FAR &, Ereal _FAR &);
extern Ereal operator -(Ereal _FAR &, Ereal _FAR &);
extern Ereal operator *(Ereal _FAR &, Ereal _FAR &);
extern Ereal operator /(Ereal _FAR &, Ereal _FAR &);
extern Ereal eleva(Ereal _FAR &, char n);
extern Ereal fatorial(char&);

extern Ereal subt_f(Ereal, Ereal);
extern Ereal mult_alg(Ereal, char);

extern Ereal raiz(Ereal _FAR &);
extern Ereal absol(Ereal _FAR &);
extern Ereal frac(Ereal _FAR &);
extern Ereal inteiro(Ereal _FAR &);

extern void mostra(Ereal _FAR &);
extern void le_numero(Ereal _FAR &);

extern double dbl(Ereal _FAR &);
extern Ereal re(double);

extern Ereal exponencial(Ereal _FAR &);
extern Ereal seno(Ereal _FAR &);
extern Ereal cosseno(Ereal _FAR &);
extern Ereal arctg(Ereal _FAR &);
#endif
